/*
 * bv2 project
 * Created on Feb 14, 2005
 *
 * Copyright (C) 2005
 * Gergely Varro
 * Department of Computer Science and Information Theory
 * Budapest University of Technology and Economics
 * Budapest, Hungary
 */
package hu.bme.cs.benchmark.mutex.db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Map;
import org.apache.log4j.PropertyConfigurator;
import hu.bme.cs.db.Edge;
import hu.bme.cs.db.Graph;
import hu.bme.cs.db.Node;
import hu.bme.cs.db.Rule;
/**
 * @author gergo
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ALAP {
    public static void main(String[] args) 
    	throws ClassNotFoundException,SQLException {
        Connection conn = null;
        Node p,p1,p2;
        Edge n1,n2;
        int N = Integer.parseInt(args[0]);
        
        PropertyConfigurator.configure("/home/gergo/PhD/bv2/code/log4j.config");
        if (conn == null) {
            Class.forName("com.mysql.jdbc.Driver");
            conn = DriverManager.getConnection(
                    "jdbc:mysql://localhost:3307/benchmark",
                    "gergo","otaniemi");
            conn.setAutoCommit(false);
        }
        // Graph meta = Mutex.generateMetaModel(conn);
        Map rule = Mutex.generateRules(conn);

        /* Initial model generation */
        Graph m = new Graph();
        p1 = new Node("process");
        m.addVertex(p1);
        Node r = new Node("resource");
        m.addVertex(r);
        Edge h = new Edge("held_by",r,p1);
        m.addEdge(h);
        p = p1;
        int i = 0;
        
        for(i = 1; i < N; i++) {
            p2 = new Node("process");
            m.addVertex(p2);
            r = new Node("resource");
            m.addVertex(r);
            h = new Edge("held_by",r,p2);
            m.addEdge(h);
            Edge e = new Edge("next",p1,p2);
            m.addEdge(e);
            p1 = p2;
        }
        Edge e = new Edge("next",p1,p);
        m.addEdge(e);
        Mutex.generateModel(conn,m);
        
        // Run tests
         try {
             int cnt = 0;
             for(cnt = 0; cnt < N; cnt++) {
                 ((Rule) rule.get("releaseRule")).apply();
             }
             for(cnt = 0; cnt < N; cnt++) {
                 ((Rule) rule.get("giveRule")).apply();
             }
             for(cnt = 0; cnt < N; cnt++) {
                 ((Rule) rule.get("requestSimpleRule")).apply();
             }
             for(cnt = 0; cnt < N; cnt++) {
                 ((Rule) rule.get("takeRule")).apply();
             }
         } catch (Exception ex) {
             System.err.println(ex.getMessage());
         }
    }
}
