/*
 * bv2 project
 * Created on Feb 14, 2005
 *
 * Copyright (C) 2005
 * Gergely Varro
 * Department of Computer Science and Information Theory
 * Budapest University of Technology and Economics
 * Budapest, Hungary
 */
package hu.bme.cs.benchmark.mutex.db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import org.apache.log4j.PropertyConfigurator;
import org.apache.log4j.Logger;
import hu.bme.cs.db.Edge;
import hu.bme.cs.db.Graph;
import hu.bme.cs.db.GraphObject;
import hu.bme.cs.db.Node;
import hu.bme.cs.db.Rule;
// import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
/**
 * @author gergo
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class STSpar {
    public static void main(String[] args) 
    	throws ClassNotFoundException,SQLException {
        Connection conn = null;
        Node p1,p2;
        Edge n1,n2;
        
        int N = Integer.parseInt(args[0]);
        PropertyConfigurator.configure("/home/gergo/PhD/bv2/code/log4j.config");
        if (conn == null) {
            Class.forName("com.mysql.jdbc.Driver");
            conn = DriverManager.getConnection(
                    "jdbc:mysql://localhost:3307/benchmark",
                    "gergo","otaniemi");
            conn.setAutoCommit(false);
        }
        // Graph meta = Mutex.generateMetaModel(conn);
        Map rule = Mutex.generateRules(conn);
        
        /* Initial model generation */
        Graph m = new Graph();
        p1 = new Node("process");
        p2 = new Node("process");
        m.addVertex(p1);
        m.addVertex(p2);
        n1 = new Edge("next",p1,p2);
        n2 = new Edge("next",p2,p1);
        m.addEdge(n1);
        m.addEdge(n2);
        Mutex.generateModel(conn,m);
        
        // Run tests
        try {
            int cnt = 0;
            for(cnt = 0; cnt < N-2; cnt++) {
                ((Rule) rule.get("newRule")).apply();
            }

            for(cnt = 0; cnt < 1; cnt++) {
                ((Rule) rule.get("mountRule")).apply();
            }
            
            for(cnt = 0; cnt < N; cnt++) {
                ((Rule) rule.get("requestRule")).apply();
            }
            
            Logger logger = Logger.getLogger(Rule.class);
            for(cnt = 0; cnt < N; cnt++) {
                Rule r = (Rule) rule.get("takeRule");
                if(logger.isDebugEnabled()) {
                    logger.debug("takeRule : init : " +
                            System.nanoTime());
                }
                Map match = r.match();
                if(logger.isDebugEnabled()) {
                    logger.debug("takeRule : pattern matching : " +
                            System.nanoTime());
                }
                r.update(match);
                r.closeLHS();
                conn.commit();
                if(logger.isDebugEnabled()) {
                    logger.debug("takeRule : update : " +
                            System.nanoTime());
                }
                int resource = 0;
                Iterator i = null;
                i = match.keySet().iterator();
                while(i.hasNext()) {
                    GraphObject go = (GraphObject) i.next();
                    if(go.getType() == "resource") {
                        resource = ((Integer) match.get(go)).intValue();
                        break;
                    }
                }

                r = (Rule) rule.get("releaseRule");
                Map newMatch = r.getEmptyMatch();
                i = newMatch.keySet().iterator();
                while(i.hasNext()) {
                    GraphObject go = (GraphObject) i.next();
                    if(go.getType() == "resource") {
                        newMatch.put((Node) go,new Integer(resource));
                        break;
                    }
                }
                
                if(logger.isDebugEnabled()) {
                    logger.debug("releaseRule : init : " +
                            System.nanoTime());
                }
                match = r.match(newMatch);
                if(logger.isDebugEnabled()) {
                    logger.debug("releaseRule : pattern matching : " +
                            System.nanoTime());
                }
                r.update(match);
                r.closeLHS();
                conn.commit();
                if(logger.isDebugEnabled()) {
                    logger.debug("releaseRule : update : " +
                            System.nanoTime());
                }

                r = (Rule) rule.get("giveRule");
                newMatch = r.getEmptyMatch();
                i = newMatch.keySet().iterator();
                while(i.hasNext()) {
                    GraphObject go = (GraphObject) i.next();
                    if(go.getType() == "resource") {
                        newMatch.put((Node) go,new Integer(resource));
                        break;
                    }
                }

                if(logger.isDebugEnabled()) {
                    logger.debug("giveRule : init : " +
                            System.nanoTime());
                }
                match = r.match(newMatch);
                if(logger.isDebugEnabled()) {
                    logger.debug("giveRule : pattern matching : " +
                            System.nanoTime());
                }
                r.update(match);
                r.closeLHS();
                conn.commit();
                if(logger.isDebugEnabled()) {
                    logger.debug("giveRule : update : " +
                            System.nanoTime());
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
